<?php
/*
Plugin Name: Tweet Tweet
Plugin URI: http://ocaoimh.ie/tweet-tweet/
Description: Archive your Twitter conversations
Version: 0.2
Author: Donncha O Caoimh
Author URI: http://ocaoimh.ie/
*/
/*  Copyright Donncha O Caoimh (http://ocaoimh.ie/)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

$wpdb->twitterarchives = $wpdb->prefix . 'twitter_archives';

function tweet_tweet_install() {
	global $wpdb;

	$wpdb->twitterarchives = $wpdb->prefix . 'twitter_archives';
	if($wpdb->get_var("SHOW TABLES LIKE '$wpdb->twitterarchives'") == $wpdb->twitterarchives)
		return true;

	$sql = "CREATE TABLE {$wpdb->twitterarchives} (
			`tid` bigint(20) NOT NULL,
			`username` varchar(100) NOT NULL,
			`description` varchar(180) NOT NULL,
			`pubdate` varchar(60) NOT NULL,
			KEY `username` (`username`),
			KEY `tid` (`tid`)
			)";
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	dbDelta($sql);
}
register_activation_hook(__FILE__,'tweet_tweet_install');

function tweet_tweet_add_pages() {
	add_options_page('Twitter', 'Twitter', 'manage_options', 'twitter-conf', 'tweet_tweet_options');
}
add_action('admin_menu', 'tweet_tweet_add_pages');

function tweet_tweet_options() {
	if ( isset($_POST['submit']) ) {
		if ( function_exists('current_user_can') && !current_user_can('manage_options') )
			die(__('Cheatin&#8217; uh?'));

		check_admin_referer( 'tweet_tweet' );
		$interval = (int)$_POST[ 'interval' ] >= 90 ? (int)$_POST[ 'interval' ] : 90;
		
		update_option( 'tweet_tweet', array( 'username' => $_POST[ 'username' ], 'password' => $_POST[ 'password' ], 'interval' => $interval, 'review' => (int)$_POST[ 'review' ], 'limit' => (int)$_POST[ 'limit' ] ) );
		archive_tweets();
	}
	if ( !empty($_POST ) ) { 
		?> <div id="message" class="updated fade"><p><strong><?php _e('Options saved.') ?></strong></p></div> <?php 
	} 
	$options = get_option( 'tweet_tweet' );
	$username = '';
	$password = '';
	$interval = 180;
	$review = 1;
	$limit = 10;
	if( is_array( $options ) )
		extract( $options );
	?>
	<div class="wrap">
	<h2><?php _e('Twitter Archiver'); ?></h2>
	<div class="narrow">
	<?php
	if( defined( "FETCH_RSS_DEFINED" ) ) {
		?><p><strong>Warning!</strong> The function fetch_rss() is already defined. It can be found either in <?php echo ABSPATH; ?>wp-includes/rss.php or may be defined in a plugin. You must comment out the following chunk of code: <blockquote><code>if ( $rss->etag and $rss->last_modified ) {<br />
                        &nbsp;&nbsp;&nbsp;&nbsp;$request_headers['If-None-Match'] = $rss->etag;<br />
                        &nbsp;&nbsp;&nbsp;&nbsp;$request_headers['If-Last-Modified'] = $rss->last_modified;<br />
                        }</code></blockquote>Twitter doesn't like those headers or the carriage returns used by the rss class.</p><?php
	}
	?>
	<form action="" method="post" id="twitter-conf" style="margin: auto; width: 400px; ">
	<h3>Twitter username and password</h3>
	<p><label>Username: <input id="username" name="username" type="text" size="15" maxlength="20" value="<?php echo $username ?>" /></label></p>
	<p><label>Password: <input id="password" name="password" type="password" size="15" maxlength="20" value="<?php echo $password ?>" /></label></p>
	<p><label>Update Interval: <input id="interval" name="interval" type="text" size="3" maxlength="3" value="<?php echo $interval ?>" /> seconds. (minimum 90 sec)</label></p>
	<h3>Twitter Review Pane</h3>
	<p><label>Enabled: <input id="review" name="review" type="checkbox" value="1"<?php if( $review ) echo " checked"; ?> /></label></p>
	<p><label>Tweets to show: <input id="limit" name="limit" type="text" size="3" value="<?php echo $limit; ?>" /></label></p>
	<?php wp_nonce_field('tweet_tweet'); ?>
	<p><input type='submit' name='submit' value='Save Options' /></p>
	</form>
	</div>
	</div>
	<?php
}

if ( !function_exists('fetch_rss') ) {
function fetch_rss ($url) {
	// initialize constants
	init();

	if ( !isset($url) ) {
		// error("fetch_rss called without a url");
		return false;
	}

	// if cache is disabled
	if ( !MAGPIE_CACHE_ON ) {
		// fetch file, and parse it
		$resp = _fetch_remote_file( $url );
		if ( is_success( $resp->status ) ) {
			return _response_to_rss( $resp );
		}
		else {
			// error("Failed to fetch $url and cache is off");
			return false;
		}
	}
	// else cache is ON
	else {
		// Flow
		// 1. check cache
		// 2. if there is a hit, make sure its fresh
		// 3. if cached obj fails freshness check, fetch remote
		// 4. if remote fails, return stale object, or error

		$cache = new RSSCache( MAGPIE_CACHE_DIR, MAGPIE_CACHE_AGE );

		if (MAGPIE_DEBUG and $cache->ERROR) {
			debug($cache->ERROR, E_USER_WARNING);
		}


		$cache_status 	 = 0;		// response of check_cache
		$request_headers = array(); // HTTP headers to send with fetch
		$rss 			 = 0;		// parsed RSS object
		$errormsg		 = 0;		// errors, if any

		if (!$cache->ERROR) {
			// return cache HIT, MISS, or STALE
			$cache_status = $cache->check_cache( $url );
		}

		// if object cached, and cache is fresh, return cached obj
		if ( $cache_status == 'HIT' ) {
			$rss = $cache->get( $url );
			if ( isset($rss) and $rss ) {
				$rss->from_cache = 1;
				if ( MAGPIE_DEBUG > 1) {
				debug("MagpieRSS: Cache HIT", E_USER_NOTICE);
			}
				return $rss;
			}
		}

		// else attempt a conditional get

		// setup headers
		if ( $cache_status == 'STALE' ) {
			$rss = $cache->get( $url );
			/*if ( $rss->etag and $rss->last_modified ) {
				$request_headers['If-None-Match'] = $rss->etag;
				$request_headers['If-Last-Modified'] = $rss->last_modified;
			}*/
		}

		$resp = _fetch_remote_file( $url, $request_headers );

		if (isset($resp) and $resp) {
			if ($resp->status == '304' ) {
				// we have the most current copy
				if ( MAGPIE_DEBUG > 1) {
					debug("Got 304 for $url");
				}
				// reset cache on 304 (at minutillo insistent prodding)
				$cache->set($url, $rss);
				return $rss;
			}
			elseif ( is_success( $resp->status ) ) {
				$rss = _response_to_rss( $resp );
				if ( $rss ) {
					if (MAGPIE_DEBUG > 1) {
						debug("Fetch successful");
					}
					// add object to cache
					$cache->set( $url, $rss );
					return $rss;
				}
			}
			else {
				$errormsg = "Failed to fetch $url. ";
				if ( $resp->error ) {
					# compensate for Snoopy's annoying habbit to tacking
					# on '\n'
					$http_error = substr($resp->error, 0, -2);
					$errormsg .= "(HTTP Error: $http_error)";
				}
				else {
					$errormsg .=  "(HTTP Response: " . $resp->response_code .')';
				}
			}
		}
		else {
			$errormsg = "Unable to retrieve RSS file for unknown reasons.";
		}

		// else fetch failed

		// attempt to return cached object
		if ($rss) {
			if ( MAGPIE_DEBUG ) {
				debug("Returning STALE object for $url");
			}
			return $rss;
		}

		// else we totally failed
		// error( $errormsg );

		return false;

	} // end if ( !MAGPIE_CACHE_ON )
} // end fetch_rss()
} else {//if ( !function_exists('fetch_rss') )
	define( 'FETCH_RSS_DEFINED', 1 );
}

function archive_tweets() {
	global $wpdb;
	$options = get_option( 'tweet_tweet' );
	if( !is_array( $options ) )
		return;
	$interval = $options[ 'interval' ] >= 90 ? $options[ 'interval' ] : 90;
	wp_clear_scheduled_hook( 'tweet_tweet' );
	if( !wp_next_scheduled( 'tweet_tweet' ) )
		wp_schedule_single_event(time()+$interval, 'tweet_tweet');
	$last_tweet = get_option( 'last_tweet' );
	if( !$last_tweet ) {
		$last_tweet = time() - $interval;
		add_option( 'last_tweet', $last_tweet );
	}
	
	// need to bypass any caching for mutex flag
	$mutex = mt_rand();
	if( !$wpdb->query( "UPDATE {$wpdb->options} SET option_value='{$mutex}' WHERE option_name='twitter_mutex'" ) )
		$wpdb->query( "INSERT INTO {$wpdb->options} ( `option_name`, `option_value`, `autoload` ) VALUES ( 'twitter_mutex', '{$mutex}', 'no' )" );
	sleep(2*mt_rand( 1, 2 ) );
	$m = $wpdb->get_var( "SELECT option_value FROM {$wpdb->options} WHERE option_name='twitter_mutex'" );
	if( $mutex != $m )
		return;
	if( $last_tweet > ( time() - $interval + 3 ) )
		return;
	update_option( 'last_tweet', time() );

	timer_start();
	define( "MAGPIE_CACHE_AGE", ( $interval - 5 ) );
	include_once( ABSPATH . WPINC . '/rss.php' );
	$last_pubdate = $wpdb->get_var( "SELECT pubdate FROM {$wpdb->twitterarchives} ORDER BY tid DESC LIMIT 0, 1" );
	$since = '';
	if( $last_pubdate )
		$since = "?since=" . urlencode( $last_pubdate );
	if( get_option( 'twitter_feed_count' ) <= 5 ) {
		$rss = fetch_rss( 'http://' . urlencode( $options[ 'username' ] ) . ":" . urlencode( $options[ 'password' ] ) . "@twitter.com/statuses/friends_timeline.rss" . $since );
		$f = "friends";
		update_option( 'twitter_feed_count', (int)get_option( 'twitter_feed_count' ) + 1 );
	} else {
		$rss = fetch_rss( 'http://' . urlencode( $options[ 'username' ] ) . ":" . urlencode( $options[ 'password' ] ) . "@twitter.com/statuses/replies.rss" );
		$items = $rss->items;
		$rss = fetch_rss( 'http://' . urlencode( $options[ 'username' ] ) . ":" . urlencode( $options[ 'password' ] ) . "@twitter.com/direct_messages.rss" );
		if( is_array( $rss->items ) ) {
			foreach( $rss->items as $item ) {
				$title = explode( ' ', $item[ 'title' ] );
				$items[] = array( 'description' => "{$title[2]}: {$item[ 'description' ]}", 'pubdate' => $item[ 'pubdate' ], 'link' => $item[ 'link' ] );
			}
			$rss->items = $items;
		}
		if( get_option( 'twitter_sent_feed_count' ) >= 3 ) {
			update_option( 'twitter_sent_feed_count', 0 );
			$sent = file_get_contents( 'http://' . urlencode( $options[ 'username' ] ) . ":" . urlencode( $options[ 'password' ] ) . "@twitter.com/direct_messages/sent.xml" );
			if( $sent ) {
				include_once( "xmlize.php" );
				$t = xmlize( $sent );
				$dm =  $t[ 'direct-messages' ]["#"][ 'direct_message' ];
				for($i = 0; $i < sizeof($dm); $i++) {
					$d = $dm[$i];
					$tid = $d['#']['id'][0]['#'];
					$description = $d['#']['text'][0]['#'];
					$pubdate = $d['#']['created_at'][0]['#'];
					$to = $d['#']['recipient_screen_name'][0]['#'];
					if( null != $wpdb->get_row( "SELECT tid from {$wpdb->twitterarchives} WHERE tid = '{$tid}'" ) )
						continue;
					$wpdb->query( "INSERT INTO {$wpdb->twitterarchives} ( `tid`, `username`, `description`, `pubdate` ) VALUES ( '" . intval( $tid ) . "', '" . addslashes( "(d) $to"  ) . "', '" . $wpdb->escape( $description ) . "', '{$pubdate}' )" );
				}
			}
		} else {
			update_option( 'twitter_sent_feed_count', (int)get_option( 'twitter_sent_feed_count' ) + 1 );
		}
		$f = "replies";
		update_option( 'twitter_feed_count', 0 );
	}
	if( !$rss->from_cache ) {
		$count = 0;
		if( !is_array( $rss->items ) )
			return;
		foreach($rss->items as $item ) {
			$link = str_replace( 'http://twitter.com/', '', $item[ 'link' ] );
			$l = explode( '/', $link );
			if( $l[0] == 'direct_messages' ) {
				$l[0] = substr( $item[ "description" ], 0, strpos( $item[ "description" ], ':' ) ) . " (d)";
				$l[2] = $l[1];
				$description = substr( $item[ "description" ], strlen( $l[0] ) - 3 );
			} else {
				$description = substr( $item[ "description" ], strlen( $l[0] ) + 2 );
			}
			$tid = $l[2];
			$username = $l[0];
			if( null != $wpdb->get_row( "SELECT tid from {$wpdb->twitterarchives} WHERE tid = '{$tid}'" ) )
				continue;
			$wpdb->query( "INSERT INTO {$wpdb->twitterarchives} ( `tid`, `username`, `description`, `pubdate` ) VALUES ( '" . intval( $tid ) . "', '" . addslashes( $username ) . "', '" . $wpdb->escape( $description ) . "', '{$item[ 'pubdate' ]}' )" );
			$count ++;
		}
	}
	$r = timer_stop();
	//error_log( "fetching $count new tweets took $r seconds" );
}
add_action( 'tweet_tweet', 'archive_tweets' );

function twitter_review_pane() {
	global $wpdb;
	$options = get_option( 'tweet_tweet' );
	if( !is_array( $options ) )
		return;

	if( !wp_next_scheduled( 'tweet_tweet' ) ) {
		wp_clear_scheduled_hook( 'tweet_tweet' );
		wp_schedule_single_event(time()+$options[ 'interval' ], 'tweet_tweet');
	}

	if( $options[ 'review' ] == 0 )
		return;

	$nonce = wp_create_nonce( 'twitterupdate' );
	$twitter_limit = $options[ 'limit' ] >= 10 ? $options[ 'limit' ] : 10;
?>
<script>
var twitterajaxenabled = 1;
var twittertweets = 'friends';
var twitterpage = 1;
var searchtwitterusername = '';
var searchtwitterdescription = '';
function toggle_twitter_updates( update ) {
	jQuery.ajax({
		type: "post",url: "admin-ajax.php",data: { action: 'twitter'+update, _ajax_nonce: '<?php echo $nonce; ?>' },
		beforeSend: function() {jQuery("#loading").show("fast");}, //show loading just when link is clicked
		complete: function() { jQuery("#loading").hide("fast");}, //stop showing loading when the process is complete
		success: function(html){ //so, if data is retrieved, store it in html
			jQuery(".twittercontent").show("slow"); //animation
		}
	}); //close jQuery.ajax(
}
function get_twitter_updates() { //start function when any link is clicked
	jQuery(".twittercontent").slideUp("slow");
	jQuery.ajax({
		type: "post",
		url: "admin-ajax.php",
		data: { action: 'twitterupdate', twittertweets: twittertweets, _ajax_nonce: '<?php echo $nonce; ?>', twitterpage: twitterpage, twitterusername: searchtwitterusername, twitterdescription: searchtwitterdescription },
		beforeSend: function() {jQuery("#loading").show("fast");}, //show loading just when link is clicked
		complete: function() { jQuery("#loading").hide("fast");}, //stop showing loading when the process is complete
		success: function(html){ //so, if data is retrieved, store it in html
			if( twittertweets != 'search' ) {
				jQuery('#hidesearchtwitter').attr( 'id', 'searchtwitter' );
				jQuery("#searchtwitterform").hide("fast");
			}
			jQuery(".twittercontent").show("slow"); //animation
			jQuery(".twittercontent").html(html); //show the html inside .twittercontent div
		}
	}); //close jQuery.ajax(
}
 
function update_twitter_review() {
	get_twitter_updates();
	jQuery('#twitterpagetitle').html( ucfirst( twittertweets ) + ', page ' + twitterpage );
}

function ucfirst( str ) {
	var f = str.charAt(0).toUpperCase();
	return f + str.substr(1, str.length-1);
}
function show_twitterreviewpane() {
	jQuery('#twitterreview').removeClass('twitterreviewpane');
	jQuery('#twitterreview').addClass('twitterreviewpanehover');
}
function hide_twitterreviewpane() {
	jQuery('#twitterreview').removeClass('twitterreviewpanehover');
	jQuery('#twitterreview').addClass('twitterreviewpane');
}

// When the document loads do everything inside here ...
jQuery(document).ready(function(){
		<?php if( $options[ 'update' ] == 1 ) { echo "		setTimeout( update_twitter_review, 92000 );\n"; } ?>
		jQuery('#twittermenu a').click(function() { //start function when any link is clicked
			if( jQuery(this).attr("id") == 'stopajax' ) {
				twitterajaxenabled = 0;
				jQuery(this).html( 'Enable Updates' );
				jQuery(this).attr( 'id', 'startajax' );
				toggle_twitter_updates( 'stop' );
			} else if( jQuery(this).attr("id") == 'startajax' ) {
				twitterajaxenabled = 1;
				jQuery(this).html( 'Disable Updates' );
				jQuery(this).attr( 'id', 'stopajax' );
				update_twitter_review();
				toggle_twitter_updates( 'start' );
				setTimeout( update_twitter_review, 92000 );
			} else if( jQuery(this).attr("id") == 'oldertwitter' ) {
				twitterpage = twitterpage + 1;
				update_twitter_review();
			} else if( jQuery(this).attr("id") == 'newertwitter' ) {
				if( twitterpage > 1 ) {
					twitterpage = twitterpage - 1;
					update_twitter_review();
				}
			} else if( jQuery(this).attr("id") == 'directtwitter' ) {
				twitterpage = 1;
				twittertweets = 'direct';
				update_twitter_review();
			} else if( jQuery(this).attr("id") == 'friendstwitter' ) {
				twitterpage = 1;
				twittertweets = 'friends';
				update_twitter_review();
			} else if( jQuery(this).attr("id") == 'repliestwitter' ) {
				twitterpage = 1;
				twittertweets = 'replies';
				update_twitter_review();
			} else if( jQuery(this).attr("id") == 'searchtwitter' ) {
				jQuery(this).attr( 'id', 'hidesearchtwitter' );
				jQuery("#searchtwitterform").show("fast");
			} else if( jQuery(this).attr("id") == 'hidesearchtwitter' ) {
				jQuery(this).attr( 'id', 'searchtwitter' );
				jQuery("#searchtwitterform").hide("fast");
			}
		})
		// http://remysharp.com/2007/03/05/jquery-ajaxed-forms/
		// http://nettuts.com/javascript-ajax/submit-a-form-without-page-refresh-using-jquery/
		jQuery( function() {
			jQuery( '#twittersearchform' ).submit( function() {
				twitterpage = 1;
				twittertweets = 'search';
				searchtwitterdescription = escape( jQuery( '#searchtwitterdescription' ).val() );
				searchtwitterusername = escape( jQuery( '#searchtwitterusername' ).val() );
				update_twitter_review();
				return false;
			})
		})
		// http://www.learningjquery.com/2007/02/quick-tip-set-hover-class-for-anything
		jQuery('#twittermenudiv').hover( show_twitterreviewpane, hide_twitterreviewpane );
		jQuery('#twitterreview').hover( show_twitterreviewpane, hide_twitterreviewpane );
})//close jQuery(
</script>
	<style type="text/css">
	.twitterreviewpanehover {
		position:absolute; left: auto; right: 0px; z-index: 1; top: 45px; width: 50%; <?php if( $twitter_limit <= 15 ) { echo "height: auto; "; } else { echo "overflow-y: scroll; height: 50%; "; } ?> background: #fff; border: 1px solid #333; display: block; padding: 2px;  padding-top: 5px;
	}
	.twitterreviewpane {
		position:absolute; left: auto; right: 0px; z-index: 1; top: 45px; width: 50%; height: 45px; background: #fff; border: 1px solid #333; <?php if( $twitter_limit > 15 ) { echo "overflow-y: scroll;"; } else { echo "overflow: hidden;"; } ?> padding: 2px; padding-top: 5px;
	}
	#loading { clear:both; background:url(images/loading.gif) center top no-repeat; text-align:center;padding:33px 0px 0px 0px; font-size:12px;display:none; font-family:Verdana, Arial, Helvetica, sans-serif; }
	#searchtwitterform { clear:both; text-align:center;padding:5px 0px 5px 0px; font-size:12px;display:none; font-family:Verdana, Arial, Helvetica, sans-serif; }
	#twittermenudiv {position:absolute; left: auto; right: 0px; z-index: 2; top: 30px; width: 50%; height: 10px; background: #fff; border: 1px solid #333; padding: 2px; padding-top: 5px;}
	#twittermenu  {list-style:none; margin:0px; padding:0px; margin-top: -5px; padding-bottom: 1px; height: 11px; text-align: right;}
	#twittermenu li {list-style:none; display:inline; font-size: 11px; margin-left: 10px; }
	#twittermenu a {text-decoration: none;}
	</style>
	<div id='twittermenudiv'><ul id='twittermenu'><li id='twitterpagetitle'>Friends, page 1</li><li><a href="#" id='friendstwitter'>Friends</a><li><a href="#" id='repliestwitter'>Replies</a><li><a href="#" id='directtwitter'>Direct</a></li><li><a href="#" id='searchtwitter'>Search</a></li><li><a href="#" style='margin-left: 20px' id='newertwitter'>&lt;&lt; Newer</a></li><li><a href="#" id='oldertwitter'>Older >></a></li><li style='margin-left: 20px;'><a href='#' <?php if( $options[ 'update' ] == 1 ) { echo "id='stopajax'>Disable Updates"; } else { echo "id='startajax'>Enable Updates"; } ?></a></li></ul></div>
	<div id='twitterreview' class='twitterreviewpane'>
	<div id="searchtwitterform"><form action="" method="POST" id='twittersearchform'>Username: <input type="text" id="searchtwitterusername" name="searchtwitterusername" value="" /> Tweet: <input type="text" id="searchtwitterdescription" name="searchtwitterdescription" value="" /> <input type="submit" name="dosearchtwitter" value="Search Twitter" /></form></div>
	<div id="loading">LOADING</div>
	<div class="twittercontent"><?php twitter_update_ajax() ?></div>
	</div><?php
}
add_action( 'admin_footer', 'twitter_review_pane' );

function toggle_twitter_updates() {
	$options = get_option( 'tweet_tweet' );
	$options[ 'update' ] = 1;
	if( $_POST[ 'action' ] == 'twitterstop' )
		$options[ 'update' ] = 0;
	update_option( 'tweet_tweet', $options );
	die();
}
add_action( 'wp_ajax_twitterstop', 'toggle_twitter_updates' );
add_action( 'wp_ajax_twitterstart', 'toggle_twitter_updates' );

function twitter_update_ajax() {
	global $wpdb;
	if( $_POST[ 'action' ] == 'twitterupdate' || $_POST[ 'twittertweets' ] )
		check_ajax_referer( "twitterupdate" );
	$options = get_option( 'tweet_tweet' );
	if( !is_array( $options ) ) {
		?>Please enter your Twitter username and password in the <a href="options-general.php?page=twitter-conf">options page</a><?php
		die();
	}
	$twitter_limit = $options[ 'limit' ] >= 10 ? $options[ 'limit' ] : 10;
	if( $_POST[ 'twitterpage' ] ) {
		$start = $twitter_limit * ( (int) $_POST[ 'twitterpage' ] - 1 );
	} else {
		$start = 0;
	}
	if( $_POST[ 'twittertweets' ] == 'direct' ) {
		$tweets = $wpdb->get_results( "SELECT * FROM {$wpdb->twitterarchives} WHERE username LIKE '%(d)%' ORDER by tid DESC LIMIT $start,$twitter_limit" );
	} elseif( $_POST[ 'twittertweets' ] == 'replies' ) {
		$tweets = $wpdb->get_results( "SELECT * FROM {$wpdb->twitterarchives} WHERE description LIKE '%@{$options[ 'username' ]}%' ORDER by tid DESC LIMIT $start,$twitter_limit" );
	} elseif( $_POST[ 'twittertweets' ] == 'search' ) {
		$where = '';
		if( $_POST[ 'twitterusername' ] )
			$where .= " username LIKE '%" . $wpdb->escape( rawurldecode( $_POST[ 'twitterusername' ] ) ) . "%' AND ";
		if( $_POST[ 'twitterdescription' ] )
			$where .= " description LIKE '%" . $wpdb->escape( rawurldecode( $_POST[ 'twitterdescription' ] ) ) . "%' AND ";
		$where = trim( $where ) . " 1=1";
		$tweets = $wpdb->get_results( "SELECT * FROM {$wpdb->twitterarchives} WHERE $where ORDER by tid DESC LIMIT $start,$twitter_limit" );
	} else {
		$tweets = $wpdb->get_results( "SELECT * FROM {$wpdb->twitterarchives} ORDER by tid DESC LIMIT $start,$twitter_limit" );
	}
	if( $tweets ) {
		echo "<table border=0 cellspacing=0 style='padding: 0px; margin: 0px;'>";
		$bg = '';
		$count = 0;
		foreach( $tweets as $tweet ) {
			if( $_POST[ 'twittertweets' ] == 'replies' ) {
				$bg = $bg == '' ? ' style="background: #efe"' : '';
			} else {
				$bg = $bg == '' ? ' style="background: #eEf1fF"' : '';
			}
			if( substr( $tweet->username, -4 ) == ' (d)' || substr( $tweet->username, 0, 4 ) == '(d) ') {
				$bg = ' style="background: #ffe"';
				$link = "http://twitter.com/direct_messages/" . $tweet->tid;
			} else {
				$link = "http://twitter.com/" . $tweet->username . "/" . $tweet->tid;
			}
			$description = ereg_replace("[[:alpha:]]+://[^<>[:space:]]+[[:alnum:]/]","<a href=\"\\0\">\\0</a>", $tweet->description);
			$description = ereg_replace("@([^<>[:space:]]+[[:alnum:]])","<a href=\"http://twitter.com/\\1\">@\\1</a>", $description);
			$tdate = date("H:i:s", ( strtotime( $tweet->pubdate ) + ( get_settings('gmt_offset') * 3600 ) ) );
			$username = $tweet->username;
			if( strpos( $tweet->username, ' (d)' ) ) {
				$username = str_replace( ' (d)', '', $username );
				$username = 'From:&nbsp;' . $username;
			} elseif( false !== strpos( $tweet->username, '(d) ' ) )  {
				$username = str_replace( '(d) ', 'To:&nbsp;', $username );
			}
			echo "<tr{$bg}><td style='border-bottom: 1px solid #ddd; margin: 2px;' valign='top'><a href='{$link}'>{$username}</a>:<br />@ $tdate</td><td style='border-bottom: 1px solid #ddd; padding-top: 2px; padding-bottom: 2px;' valign='top'> {$description}</td></tr>";
		}
		echo "</table>";
	} elseif( $_POST[ 'twittertweets' ] == 'search' ) {
		?><p>No tweets found for that search.</p><?php
	} else {
		?><p>No tweets archived yet. Make sure your theme has the "wp_footer" action. &lt;?php do_action('wp_footer'); ?&gt; must be in the footer.php or in some other theme file.</p><?php
	}
	if( $_POST[ 'action' ] == 'twitterupdate' )
		die();
}
add_action( 'wp_ajax_twitterupdate', 'twitter_update_ajax' );

function my_tweets( $limit = 5 ) {
	$tweets = get_my_tweets( $limit );
	foreach( $tweets as $t ) {
		$description = ereg_replace("[[:alpha:]]+://[^<>[:space:]]+[[:alnum:]/]","<a href=\"\\0\">\\0</a>", $t->description);
		echo "<li>{$description} <a href='http://twitter.com/{$t->username}/statuses/{$t->tid}/'>#</a></li>";
	}
}

function get_my_tweets( $limit = 5 ) {
	global $wpdb;
	$options = get_option( 'tweet_tweet' );
	if( !is_array( $options ) )
		return array();
	$tweets = wp_cache_get( "mytweets", 'widget' );
	$tweets = false;
	if( !is_array( $tweets ) ) {
		$tweets = $wpdb->get_results( "SELECT * FROM {$wpdb->twitterarchives} WHERE username = '{$options[ 'username' ]}' ORDER BY tid DESC LIMIT 0, $limit" );
		wp_cache_add( 'mytweets', $tweets, 'widget' );
	}

	return $tweets;
}
?>
